#!/bin/sh
vbPTN1="s%^DISTRO_VERSION=.*%DISTRO_VERSION=6.0.1%"
sed -i -e "$vbPTN1" /etc/DISTRO_SPECS

UExtract_PATH="/usr/local/apps/UExtract"

if [ "`pwd`" = "/" ]; then
  OpenWith_PATH="$HOME/.config/rox.sourceforge.net/OpenWith"
  DOTdesktop_PATH="/usr/share/applications/UExtract.desktop"
else	# Woof
  OpenWith_PATH="./root/.config/rox.sourceforge.net/OpenWith"
  DOTdesktop_PATH="./usr/share/applications/UExtract.desktop"
fi

if [ -d "$OpenWith_PATH" ]; then

  # BTW, Mime-Types are kept inside UExtract.desktop file
  if [ -d "$OpenWith_PATH" ]; then
    for i in $(grep '^MimeType=' "$DOTdesktop_PATH" | cut -f2- -d '=' | tr ';' '\n' | tr '/' '_' | head -n -1); do
      [ ! -d "${OpenWith_PATH}/.${i}" ] && mkdir "${OpenWith_PATH}/.${i}" 
      [ ! -L "${OpenWith_PATH}/.${i}/UExtract" ] && ln -s "$UExtract_PATH" "${OpenWith_PATH}/.${i}/UExtract"
    done
    [ ! -L "${OpenWith_PATH}/UExtract" ] && ln -s "$UExtract_PATH" "${OpenWith_PATH}/UExtract"
  fi

fi

# Associate custom action with Thunar
if [ "`pwd`" = "/" ]; then
  if [ `which thunar 2>/dev/null` ] || [ `which Thunar 2>/dev/null` ]; then
    CONFIG="$HOME/.config/Thunar/uca.xml"
    CONFIG_BAK="$HOME/.config/Thunar/uca.xml.bak"
    CONFIG_TMP=/tmp/uca.xml
    EXTENSIONS="`uextract -f | grep -vE '\[|\]|\?' | grep '^\.' | tr '\n' ';' | sed 's/\./\*\./g'`"
    if [ -f "$CONFIG" ]; then
      grep '<name>UExtract</name>' "$CONFIG" >/dev/null || {
      grep -v '^</actions>' "$CONFIG" > "$CONFIG_TMP"
      echo '<action>
	<icon>UExtract</icon>
	<name>UExtract</name>
	<command>/usr/local/apps/UExtract/AppRun %F</command>
	<description>Extract packages</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<other-files/>
	<audio-files/>
	<video-files/>
</action>
</actions>' >> "$CONFIG_TMP"
      mv "$CONFIG" "$CONFIG_BAK"
      mv "$CONFIG_TMP" "$CONFIG"
    }
    else
      mkdir -p "${CONFIG%/*}"
      echo '<?xml encoding="UTF-8" version="1.0"?>
<actions>
<action>
	<icon>UExtract</icon>
	<name>UExtract</name>
	<command>/usr/local/apps/UExtract/AppRun %F</command>
	<description>Extract packages</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<other-files/>
	<audio-files/>
	<video-files/>
</action>
</actions>' > "$CONFIG" 
    fi
  fi
fi

PackIt_PATH="/usr/local/apps/PackIt"

if [ "`pwd`" = "/" ]; then
  OpenWith_PATH="$HOME/.config/rox.sourceforge.net/OpenWith"
  Globs_PATH="/usr/share/mime/globs"
  Types_PATH="/usr/share/mime/types"
else	# Woof
  OpenWith_PATH="./root/.config/rox.sourceforge.net/OpenWith"
  Globs_PATH="./usr/share/mime/globs"
  Types_PATH="./usr/share/mime/types"
fi

if [ -d "$OpenWith_PATH" ]; then

  # Creates missing folders using contents of 'globs' file
  for i in `grep ":" "$Globs_PATH" | cut -f1 -d ':' | tr '/' '_' | uniq`; do
    [ ! -d "${OpenWith_PATH}/.${i}" ] && mkdir "${OpenWith_PATH}/.${i}"
  done
  
  # Creates missing folders using contents of 'types' file
  for i in `cat "$Types_PATH" | tr '/' '_' | uniq`; do
    [ ! -d "${OpenWith_PATH}/.${i}" ] && mkdir "${OpenWith_PATH}/.${i}" 
  done
  
  [ ! -d "${OpenWith_PATH}/.inode_unknown" ] && mkdir "${OpenWith_PATH}/.inode_unknown"
  
  # Creates symlink to PackIt in every folder
  for i in `find "$(realpath "${OpenWith_PATH}")" -maxdepth 1 -type d -iname ".*"`; do
    [ ! -L "${i}/PackIt" ] && ln -s "$PackIt_PATH" "${i}/PackIt"
  done
  [ ! -L "${OpenWith_PATH}/PackIt" ] && ln -s "$PackIt_PATH" "${OpenWith_PATH}/PackIt"
  
fi

# Associate custom action with Thunar
if [ "`pwd`" = "/" ]; then
  if [ `which thunar 2>/dev/null` ] || [ `which Thunar 2>/dev/null` ]; then
    CONFIG="$HOME/.config/Thunar/uca.xml"
    CONFIG_BAK="$HOME/.config/Thunar/uca.xml.bak"
    CONFIG_TMP=/tmp/uca.xml
    if [ -f "$CONFIG" ]; then
      grep '<name>PackIt</name>' "$CONFIG" >/dev/null || {
      grep -v '^</actions>' "$CONFIG" > "$CONFIG_TMP"
      echo '<action>
	<icon>PackIt</icon>
	<name>PackIt</name>
	<command>/usr/local/apps/PackIt/AppRun %F</command>
	<description>Archive files</description>
	<patterns>*</patterns>
	<directories/>
	<audio-files/>
	<image-files/>
	<other-files/>
	<text-files/>
	<video-files/>
</action>
</actions>' >> "$CONFIG_TMP"
      mv "$CONFIG" "$CONFIG_BAK"
      mv "$CONFIG_TMP" "$CONFIG"
    }
    else
      mkdir -p "${CONFIG%/*}"
      echo '<?xml encoding="UTF-8" version="1.0"?>
<actions>
<action>
	<icon></icon>
	<name>PackIt</name>
	<command>/usr/local/apps/PackIt/AppRun %F</command>
	<description>Archive files</description>
	<patterns>*</patterns>
	<directories/>
	<audio-files/>
	<image-files/>
	<other-files/>
	<text-files/>
	<video-files/>
</action>
</actions>' > "$CONFIG" 
    fi
  fi
fi

fixmenus; jwm -reload
echo "docsLocation = /usr/share/doc/mtpaint/index.html" >> /root/.mtpaint

if /usr/local/quickpet_precise/checks/alsafix2
then
rm /usr/local/quickpet_precise/checks/alsamixer
else
mv /usr/bin/alsamixer /usr/bin/alsamixer.bin
mv /usr/local/quickpet_precise/checks/alsamixer /usr/bin/alsamixer
fi
sleep 1
echo "#!/bin/sh" > /usr/local/quickpet_precise/checks/alsafix2
chmod a+x /usr/local/quickpet_precise/checks/alsafix2

rm /root/.config/rox.sourceforge.net/OpenWith/.application_x-rar/Unrar

if /usr/local/quickpet_precise/checks/certificates
then
touch /tmp/throwaway
else
update-ca-certificates
fi
sleep 1
echo "#!/bin/sh" > /usr/local/quickpet_precise/checks/certificates
chmod a+x /usr/local/quickpet_precise/checks/certificates

rm /usr/bin/deadbeef
echo "#!/bin/sh" > /usr/bin/deadbeef
echo "cd /opt/deadbeef" >> /usr/bin/deadbeef
echo "./deadbeef" >> /usr/bin/deadbeef
chmod a+x /usr/bin/deadbeef

rm -f /usr/local/peteget/ui_Ziggy
echo Ziggy > /var/local/petget/ui_choice

if /usr/local/quickpet_precise/checks/wakeupbug
then
touch /tmp/throwaway
else
echo enabled > /sys/bus/usb/devices/usb1/power/wakeup
echo enabled > /sys/bus/usb/devices/usb2/power/wakeup
echo enabled > /sys/bus/usb/devices/usb3/power/wakeup
echo enabled > /sys/bus/usb/devices/usb4/power/wakeup
echo enabled > /sys/bus/usb/devices/usb5/power/wakeup
echo enabled > /sys/bus/usb/devices/usb6/power/wakeup
echo enabled > /sys/bus/usb/devices/usb7/power/wakeup
echo enabled > /sys/bus/usb/devices/usb8/power/wakeup
echo enabled > /sys/bus/usb/devices/usb9/power/wakeup
echo enabled > /sys/bus/usb/devices/usb10/power/wakeup
echo ""  >> /etc/rc.d/rc.local
echo "echo enabled > /sys/bus/usb/devices/usb1/power/wakeup" >> /etc/rc.d/rc.local
echo "echo enabled > /sys/bus/usb/devices/usb2/power/wakeup" >> /etc/rc.d/rc.local
echo "echo enabled > /sys/bus/usb/devices/usb3/power/wakeup" >> /etc/rc.d/rc.local
echo "echo enabled > /sys/bus/usb/devices/usb4/power/wakeup" >> /etc/rc.d/rc.local
echo "echo enabled > /sys/bus/usb/devices/usb5/power/wakeup" >> /etc/rc.d/rc.local
echo "echo enabled > /sys/bus/usb/devices/usb6/power/wakeup" >> /etc/rc.d/rc.local
echo "echo enabled > /sys/bus/usb/devices/usb7/power/wakeup" >> /etc/rc.d/rc.local
echo "echo enabled > /sys/bus/usb/devices/usb8/power/wakeup" >> /etc/rc.d/rc.local
echo "echo enabled > /sys/bus/usb/devices/usb9/power/wakeup" >> /etc/rc.d/rc.local
echo "echo enabled > /sys/bus/usb/devices/usb10/power/wakeup" >> /etc/rc.d/rc.local
fi
sleep 1
echo "#!/bin/sh" > /usr/local/quickpet_precise/checks/wakeupbug 
chmod a+x /usr/local/quickpet_precise/checks/wakeupbug

if /usr/local/quickpet_precise/checks/deadbeeffix
then
touch /tmp/throwaway
else
rm /usr/local/bin/defaultaudioplayer
mv /usr/local/quickpet_precise/checks/defaultaudioplayer /usr/local/bin/
 fi
sleep 1
echo "#!/bin/sh" > /usr/local/quickpet_precise/checks/deadbeeffix
chmod a+x /usr/local/quickpet_precise/checks/deadbeeffix

if /usr/local/quickpet_precise/checks/alsafix
then
touch /tmp/throwaway
else
echo "#!/bin/sh"  > /root/Startup/alsa
echo "sleep 5" >> /root/Startup/alsa
echo "exec /etc/init.d/10alsa start" >> /root/Startup/alsa
chmod a+x  /root/Startup/alsa
 fi
sleep 1
echo "#!/bin/sh" > /usr/local/quickpet_precise/checks/alsafix
chmod a+x /usr/local/quickpet_precise/checks/alsafix

if find /sys/class/backlight/acpi_video0/brightness
then
echo ""  >> /etc/rc.d/rc.local
echo 'brightness=`cat /root/.config/brightness.conf`' >> /etc/rc.d/rc.local
echo 'echo $brightness > /sys/class/backlight/acpi_video0/brightness' >> /etc/rc.d/rc.local
 fi
 
Xdialog --title "Servicepack 6.0 - 6.0.2" --stdout --yesno "Tahrpup has been updated to 6.0.2

The update includes all bugfixes to date, and the latest quickpet.
See 'quickpet>>>help>>>installed bugfixes' for the complete list.


The file manager 'ROX-Filer' has also been updated but 
needs to be restarted to complete the process.
However if you're in the middle of copying files you really
don't want to do this so just click 'NO' and the update will 
be applied next time you restart X.  Otherwise click 'YES" 19 80

case $? in

1)
yaf-splash -bg green -fg white -placement center -text "restart X to complete update"
		exit
		;;
0)
cd /root
killall ROX-Filer
rox -p ~/Choices/ROX-Filer/PuppyPin
yaf-splash -bg green -fg white -placement center -timeout 5 -text updated
		;;
	esac
